/*******************************************************************
 * This file is part of the Emulex Linux Device Driver for         *
 * Fibre Channel Host Bus Adapters.                                *
 * Copyright (C) 2003-2005 Emulex.  All rights reserved.           *
 * EMULEX and SLI are trademarks of Emulex.                        *
 * www.emulex.com                                                  *
 *                                                                 *
 * This program is free software; you can redistribute it and/or   *
 * modify it under the terms of version 2 of the GNU General       *
 * Public License as published by the Free Software Foundation.    *
 * This program is distributed in the hope that it will be useful. *
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND          *
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE      *
 * DISCLAIMED, EXCEPT TO THE EXTENT THAT SUCH DISCLAIMERS ARE HELD *
 * TO BE LEGALLY INVALID.  See the GNU General Public License for  *
 * more details, a copy of which can be found in the file COPYING  *
 * included with this package.                                     *
 *******************************************************************/

/*
 * $Id: ioctls/lpfc_hbaapi_ioctl.h 1.10.1.2 2005/06/13 17:15:44EDT sf_support Exp  $
 */

#include "hbaapi.h"
#ifndef H_LPFC_HBAAPI_IOCTL
#define H_LPFC_HBAAPI_IOCTL
int lpfc_process_ioctl_hbaapi(struct lpfc_hba *phba, LPFCCMDINPUT_t *cip);
int lpfc_ioctl_hba_adapterattributes(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_portattributes(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_portstatistics(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_wwpnportattributes(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_discportattributes(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_indexportattributes(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_setmgmtinfo(struct lpfc_hba *, LPFCCMDINPUT_t *);
int lpfc_ioctl_hba_getmgmtinfo(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_refreshinfo(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_rnid(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_getevent(struct lpfc_hba *, LPFCCMDINPUT_t *, void *);
int lpfc_ioctl_hba_fcptargetmapping(struct lpfc_hba *, LPFCCMDINPUT_t *, void *, int *);
int lpfc_ioctl_hba_fcpbinding(struct lpfc_hba *, LPFCCMDINPUT_t *, void *, int, int *);
int lpfc_ioctl_port_attrib(struct lpfc_hba *, void *);
int lpfc_ioctl_found_port(struct lpfc_hba *, struct lpfc_nodelist *, void *, MAILBOX_t *, HBA_PORTATTRIBUTES *);
void lpfc_decode_firmware_rev(struct lpfc_hba *, char *, int);
int lpfc_issue_rptlun(struct lpfc_hba *, void *, struct lpfc_target *);
#ifdef LUN_WORK_COMPLETE
uint64_t dfc_get_lun_id(void *, struct lpfc_lun *, uint64_t);
#else
uint64_t dfc_get_lun_id(void *, void *, uint64_t);
#endif
#endif
